﻿package {
	/*
	copyright Qwaz(qwazpia@gmail.com)

	MIT License
	Regex Plugin v1.1

	http://blog.naver.com/yechan54/10136376088
	*/

	import com.qwazlab.NamemaN.Plugin;
	import flash.events.Event;
	
	public class Regex extends Plugin {
		public var regexPattern:RegExp;
		
		public function Regex():void {
			_pluginName = 'Regex';
			_version = 1.1;
			
			before.addEventListener(Event.CHANGE, propertyChanged);
			after.addEventListener(Event.CHANGE, propertyChanged);
		}
		
		override public function update():void {
			var index:int = before.text.lastIndexOf('::');
			if(index == -1){
				regexPattern = new RegExp(before.text);
			} else {
				regexPattern = new RegExp(before.text.substr(0, index), before.text.substr(index+1, before.text.length-index));
			}
		}
		
		override public function convert(input:String):String {
			return input.replace(regexPattern, after.text);
		}
		
		private function propertyChanged(e:Event):void {
			if(this.updateExternal != null) this.updateExternal();
		}
	}
}
